# Practicum-5-.NET

Jenkins: [![Build Status](https://jenkins.rubend.nl/buildStatus/icon?job=gitea%2Fpracticum-5-net-2020-v2b-ruben%2Fmain)](https://jenkins.rubend.nl/blue/organizations/jenkins/gitea%2Fpracticum-5-net-2020-v2b-ruben)

Deployment(via docker): [tetris.rubend.nl](https://tetris.rubend.nl) **Let op!** de needs-dotnet versies lijken wat problemen te hebben, op windows maar ook op linux. het joinen van een game gaat niet goed, en crashed de game. probeer de standalone versie.

# Controls
arrow keys=moving around  
z,x=rotate  
c=hold

# Info

Omdat ik geen webhooks kon maken op github, heb ik de github repo gecloned op mijn [gitea](https://gitea.rubend.nl/autobuild/practicum-5-net-2020-v2b-ruben). (deze heb ik vandaag, 2021-06-15, openbaar gemaakt) Deze haalt regelmatig de repo op van github.

Als de gitea wordt geupdated wordt [jenkins](https://jenkins.rubend.nl/job/gitea/job/lalaland-to-pi/job/master/) gestart met een webhook.

Jenkins maakt op een x64 laptop hierzo met behulp van docker de frontend voor linux en windows, beide met en zonder dotnet included.

daarna wordt de backend gecompileert voor arm/v7, de architecture voor mijn raspberry pi. daar wordt een docker van gemaakt `docker pull docker.rubend.nl/tetris` (werkt alleen op raspberry pi!)  
ik heb gekozen om hem alleen voor de raspberry pi te maken omdat dat makkelijker is dan meerdere architectures.

Die docker container wordt gedeployed op de raspberry pi, die altijd aan staat. Met behulp van apache2 wordt tetris.rubend.nl geforwarded naar de docker container.

# Vrije ruimte

* Gebruik van Docker
* [Gebruik van Jenkins](https://jenkins.rubend.nl/job/gitea/job/lalaland-to-pi/job/master/)
* Oneindig veel spelers multiplayer
* Oneindig veel rooms
* [Gehoste server](https://tetris.rubend.nl)
* [Bag system](https://tetris.fandom.com/wiki/Random_Generator)

# Bekende problemen/niet geimplementeerde features

* Doordat de server alles moet verwerken voordat het naar de clients wordt gestuurt, kan er een (kleine) vertraging zitten tussen een keypress en de reactie daarop. dit komt doordat de timer op de server draait, en er anders een desync mogelijk is tussen de clients.
* als een speler het spel verlaat, blijft zijn "game" doorgaan bij de andere spelers.

# Instructies

start de applicatie. Als je multiplayer wilt spelen, kan je een roomID en naam invullen. beide zijn niet verplicht. roomID heeft een default van "EMPTY". Klik op Join. wacht totdat alle andere spelers er zijn, en klik op start.

Als je singleplayer wilt spelen, klik op singleplayer, en daarna start.
